package com.xunmei.system.service.impl;

import cn.hutool.core.util.ObjectUtil;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.xunmei.common.core.constant.CacheConstants;
import com.xunmei.common.core.constant.Constants;
import com.xunmei.common.core.constant.UserConstants;
import com.xunmei.common.core.exception.ServiceException;
import com.xunmei.common.core.text.Convert;
import com.xunmei.common.core.utils.SpringUtils;
import com.xunmei.common.core.utils.StringUtils;
import com.xunmei.common.datascope.annotation.DataScope;
import com.xunmei.common.redis.utils.RedisUtils;
import com.xunmei.common.security.utils.SecurityUtils;
import com.xunmei.system.api.domain.SysDept;
import com.xunmei.system.api.domain.SysOrg;
import com.xunmei.system.api.domain.SysRole;
import com.xunmei.system.api.domain.SysUser;
import com.xunmei.system.domain.vo.TreeSelect;
import com.xunmei.system.mapper.SysDeptMapper;
import com.xunmei.system.mapper.SysOrgMapper;
import com.xunmei.system.mapper.SysRoleMapper;
import com.xunmei.system.service.ISysDeptService;
import com.xunmei.system.service.ISysOrgService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.*;
import java.util.stream.Collectors;

/**
 * 部门管理 服务实现
 *
 * @author xunmei
 */
@Service
public class SysDeptServiceImpl extends ServiceImpl<SysDeptMapper, SysDept> implements ISysDeptService {
    @Autowired
    private SysDeptMapper deptMapper;

    @Autowired
    private SysRoleMapper roleMapper;
    @Autowired
    private SysOrgMapper orgMapper;

    @Autowired
    private ISysOrgService orgService;


    /**
     * 查询部门管理数据
     *
     * @param dept 部门信息
     * @return 部门信息集合
     */
    @Override
    @DataScope(deptAlias = "d")
    public List<SysDept> selectDeptList(SysDept dept) {
        return deptMapper.selectDeptList(dept);
    }

    /**
     * 递归方法转换成树形结构
     *
     * @param treeList
     * @return
     */
    public static List<SysOrg> recursionMethod(List<SysOrg> treeList, Long parentId) {
        List<SysOrg> trees = new ArrayList<>();
        SysOrg root = null;
        if (-1L == parentId) {
            Optional<SysOrg> first = treeList.stream().filter(sysOrg -> sysOrg.getParentId().equals(-1L)).findFirst();
            root = first.get();
        } else {
            Optional<SysOrg> first = treeList.stream().filter(sysOrg -> sysOrg.getId().equals(parentId)).findFirst();
            root = first.get();
        }
        trees.add(findChildren(root, treeList));
        return trees;
    }

    public static List<SysOrg> handleTree(Map<Long, List<SysOrg>> map, Long parentId) {
        final List<SysOrg> orgList = map.get(parentId);
        if (ObjectUtil.isNotEmpty(orgList)) {
            orgList.forEach(org -> {
                final List<SysOrg> tree = handleTree(map, org.getId());
                org.setChildren(tree);
            });
        }
        return orgList;
    }

    @Override
    public List<SysDept> selectDeptTreeList(SysDept dept) {
        final LambdaQueryWrapper<SysDept> wrapper = new LambdaQueryWrapper<>();
        wrapper.eq(SysDept::getDelFlag, 0L);
        wrapper.isNotNull(SysDept::getParentId);
        List<SysDept> sysDepts = deptMapper.selectList(new QueryWrapper<>(dept));
        return recursionDept(sysDepts);
    }

    /**
     * 查询部门树结构信息
     *
     * @param dept 部门信息
     * @return 部门树信息集合
     */
    @Override
    public List<SysOrg> selectDeptTreeList(SysOrg dept) {
        Long s= System.currentTimeMillis();
        Long userId = SecurityUtils.getUserId();
        SysOrg sysOrg = orgMapper.selectSysOrgByUserId(userId);
        if (ObjectUtil.isNull(sysOrg)) {
            throw new ServiceException("当前用户没有部门信息");
        }
        //List<SysOrg> cacheList = redisService.getCacheList(CacheConstants.ORG_CACHE_LIST_KEY);
        Boolean isOk = RedisUtils.hasKey(CacheConstants.ORG_CACHE_LIST_KEY);
        if(!isOk){
            orgService.loadingOrgCache();
        }
        List<SysOrg> cacheList = RedisUtils.getCacheList(CacheConstants.ORG_CACHE_LIST_KEY);
        List<SysOrg> orgs = new ArrayList<>();
        for (SysOrg org : cacheList) {
            String path = org.getPath();
            if(StringUtils.isNotEmpty(path) && path.startsWith(sysOrg.getPath())){
                orgs.add(org);
            }
        }

        /*final LambdaQueryWrapper<SysOrg> wrapper = new LambdaQueryWrapper<>();
        wrapper.eq(SysOrg::getDeleted, 0);
        wrapper.isNotNull(SysOrg::getParentId);*/
        Long parentId = Constants.TOP_ORG_PARENT_ID;
        if (ObjectUtil.notEqual(Constants.TOP_ORG_PARENT_ID, sysOrg.getParentId())) {
            parentId = sysOrg.getParentId();
            //wrapper.likeRight(SysOrg::getPath, sysOrg.getPath());
        }
        /*List<SysOrg> depts = orgMapper.selectList(wrapper);*/
        final Map<Long, List<SysOrg>> collect = orgs.stream().collect(Collectors.groupingBy(SysOrg::getParentId));
        List<SysOrg> r= handleTree(collect, parentId);
        s=System.currentTimeMillis()-s;
        return r;
    }

    /**
     * dept递归方法转换成树形结构
     *
     * @param treeList
     * @return
     */
    public static List<SysDept> recursionDept(List<SysDept> treeList) {
        List<SysDept> trees = new ArrayList<>();
        for (SysDept tree : treeList) {
            // 找出父节点
            if (-1 == tree.getParentId()) {
                // 调用递归方法填充子节点列表
                trees.add(findChildren(tree, treeList));
            }
        }
        return trees;
    }

    /**
     * dept递归方法
     *
     * @param tree     父节点对象
     * @param treeList 所有的List
     * @return
     */
    public static SysDept findChildren(SysDept tree, List<SysDept> treeList) {
        for (SysDept node : treeList) {
            if (tree.getDeptId().equals(node.getParentId())) {
                if (tree.getChildren() == null) {
                    tree.setChildren(new ArrayList<>());
                }
                // 递归 调用自身
                tree.getChildren().add(findChildren(node, treeList));
            }
        }
        return tree;
    }

    /**
     * 递归方法
     *
     * @param tree     父节点对象
     * @param treeList 所有的List
     * @return
     */
    public static SysOrg findChildren(SysOrg tree, List<SysOrg> treeList) {
        for (SysOrg node : treeList) {
            if (tree.getId().equals(node.getParentId())) {
                if (tree.getChildren() == null) {
                    tree.setChildren(new ArrayList<>());
                }
                // 递归 调用自身
                tree.getChildren().add(findChildren(node, treeList));
            }
        }
        return tree;
    }


    /**
     * 构建前端所需要树结构
     *
     * @param depts 部门列表
     * @return 树结构列表
     */
    @Override
    public List<SysOrg> buildDeptTree(List<SysOrg> depts) {
        List<SysOrg> returnList = new ArrayList<SysOrg>();
        List<Long> tempList = depts.stream().map(SysOrg::getId).collect(Collectors.toList());
        for (SysOrg dept : depts) {
            // 如果是顶级节点, 遍历该父节点的所有子节点
            if (!tempList.contains(dept.getParentId())) {
                recursionFn(depts, dept);
                returnList.add(dept);
            }
        }
        if (returnList.isEmpty()) {
            returnList = depts;
        }
        return returnList;
    }

    /**
     * 构建前端所需要下拉树结构
     *
     * @param depts 部门列表
     * @return 下拉树结构列表
     */
    @Override
    public List<TreeSelect> buildDeptTreeSelect(List<SysOrg> depts) {
        List<SysOrg> deptTrees = buildDeptTree(depts);
        return deptTrees.stream().map(TreeSelect::new).collect(Collectors.toList());
    }

    /**
     * 根据角色ID查询部门树信息
     *
     * @param roleId 角色ID
     * @return 选中部门列表
     */
    @Override
    public List<Long> selectDeptListByRoleId(Long roleId) {
        SysRole role = roleMapper.selectRoleById(roleId);
        return deptMapper.selectDeptListByRoleId(roleId, true);
    }

    /**
     * 根据部门ID查询信息
     *
     * @param deptId 部门ID
     * @return 部门信息
     */
    @Override
    public SysDept selectDeptById(Long deptId) {
        return deptMapper.selectDeptById(deptId);
    }

    /**
     * 根据ID查询所有子部门（正常状态）
     *
     * @param deptId 部门ID
     * @return 子部门数
     */
    @Override
    public int selectNormalChildrenDeptById(Long deptId) {
        return deptMapper.selectNormalChildrenDeptById(deptId);
    }

    /**
     * 是否存在子节点
     *
     * @param deptId 部门ID
     * @return 结果
     */
    @Override
    public boolean hasChildByDeptId(Long deptId) {
        int result = deptMapper.hasChildByDeptId(deptId);
        return result > 0;
    }

    /**
     * 查询部门是否存在用户
     *
     * @param deptId 部门ID
     * @return 结果 true 存在 false 不存在
     */
    @Override
    public boolean checkDeptExistUser(Long deptId) {
        int result = deptMapper.checkDeptExistUser(deptId);
        return result > 0;
    }

    /**
     * 校验部门名称是否唯一
     *
     * @param dept 部门信息
     * @return 结果
     */
    @Override
    public boolean checkDeptNameUnique(SysDept dept) {
        Long deptId = StringUtils.isNull(dept.getDeptId()) ? -1L : dept.getDeptId();
        SysDept info = deptMapper.checkDeptNameUnique(dept.getDeptName(), dept.getParentId());
        if (StringUtils.isNotNull(info) && info.getDeptId().longValue() != deptId.longValue()) {
            return UserConstants.NOT_UNIQUE;
        }
        return UserConstants.UNIQUE;
    }

    /**
     * 校验部门是否有数据权限
     *
     * @param deptId 部门id
     */
    @Override
    public void checkDeptDataScope(Long deptId) {
        if (!SysUser.isAdmin(SecurityUtils.getUserId())) {
            SysDept dept = new SysDept();
            dept.setDeptId(deptId);
            List<SysDept> depts = SpringUtils.getAopProxy(this).selectDeptList(dept);
            if (StringUtils.isEmpty(depts)) {
                throw new ServiceException("没有权限访问部门数据！");
            }
        }
    }

    /**
     * 新增保存部门信息
     *
     * @param dept 部门信息
     * @return 结果
     */
    @Override
    public int insertDept(SysDept dept) {
        SysDept info = deptMapper.selectDeptById(dept.getParentId());
        // 如果父节点不为正常状态,则不允许新增子节点
        if (!UserConstants.DEPT_NORMAL.equals(info.getStatus())) {
            throw new ServiceException("部门停用，不允许新增");
        }
        dept.setAncestors(info.getAncestors() + "," + dept.getParentId());
        return deptMapper.insertDept(dept);
    }

    /**
     * 修改保存部门信息
     *
     * @param dept 部门信息
     * @return 结果
     */
    @Override
    public int updateDept(SysDept dept) {
        SysDept newParentDept = deptMapper.selectDeptById(dept.getParentId());
        SysDept oldDept = deptMapper.selectDeptById(dept.getDeptId());
        if (StringUtils.isNotNull(newParentDept) && StringUtils.isNotNull(oldDept)) {
            String newAncestors = newParentDept.getAncestors() + "," + newParentDept.getDeptId();
            String oldAncestors = oldDept.getAncestors();
            dept.setAncestors(newAncestors);
            updateDeptChildren(dept.getDeptId(), newAncestors, oldAncestors);
        }
        int result = deptMapper.updateDept(dept);
        if (UserConstants.DEPT_NORMAL.equals(dept.getStatus()) && StringUtils.isNotEmpty(dept.getAncestors())
                && !StringUtils.equals("0", dept.getAncestors())) {
            // 如果该部门是启用状态，则启用该部门的所有上级部门
            updateParentDeptStatusNormal(dept);
        }
        return result;
    }

    /**
     * 修改该部门的父级部门状态
     *
     * @param dept 当前部门
     */
    private void updateParentDeptStatusNormal(SysDept dept) {
        String ancestors = dept.getAncestors();
        Long[] deptIds = Convert.toLongArray(ancestors);
        deptMapper.updateDeptStatusNormal(deptIds);
    }

    /**
     * 修改子元素关系
     *
     * @param deptId       被修改的部门ID
     * @param newAncestors 新的父ID集合
     * @param oldAncestors 旧的父ID集合
     */
    public void updateDeptChildren(Long deptId, String newAncestors, String oldAncestors) {
        List<SysDept> children = deptMapper.selectChildrenDeptById(deptId);
        for (SysDept child : children) {
            child.setAncestors(child.getAncestors().replaceFirst(oldAncestors, newAncestors));
        }
        if (children.size() > 0) {
            deptMapper.updateDeptChildren(children);
        }
    }

    /**
     * 删除部门管理信息
     *
     * @param deptId 部门ID
     * @return 结果
     */
    @Override
    public int deleteDeptById(Long deptId) {
        return deptMapper.deleteDeptById(deptId);
    }

    /**
     * 递归列表
     */
    private void recursionFn(List<SysOrg> list, SysOrg t) {
        // 得到子节点列表
        List<SysOrg> childList = getChildList(list, t);
        t.setChildren(childList);
        for (SysOrg tChild : childList) {
            if (hasChild(list, tChild)) {
                recursionFn(list, tChild);
            }
        }
    }

    /**
     * 得到子节点列表
     */
    private List<SysOrg> getChildList(List<SysOrg> list, SysOrg t) {
        List<SysOrg> tlist = new ArrayList<SysOrg>();
        Iterator<SysOrg> it = list.iterator();
        while (it.hasNext()) {
            SysOrg n = (SysOrg) it.next();
            if (StringUtils.isNotNull(n.getParentId()) && n.getParentId().longValue() == t.getId().longValue()) {
                tlist.add(n);
            }
        }
        return tlist;
    }

    /**
     * 判断是否有子节点
     */
    private boolean hasChild(List<SysOrg> list, SysOrg t) {
        return getChildList(list, t).size() > 0 ? true : false;
    }
}
